<template lang="pug">
  section.editor
    .wrapper
      .editor__description
        h2.description__title <span class="description__title--outline">Create your</span> realistic<br/>photos <span class="description__title--outline">in minutes</span>
        p.description__description Choose from thousands of models, objects, and backgrounds to perfectly tell any story.
        a.description__link#link(href="/creator/dashboard")
          span.link__label Create first photo
          .link__icon(v-html="$icons.buttonArrow")
      .editor__frame
        .frame__objects
          .objects__row
            .row__title
              .title__icon(v-html="$icons.models")
              span.title__text Models
            .row__list
                img.list__item(v-for="(model, index) in models.items" :src="model.path" :class="models.active === index && 'list__item--active'" @click="handleClick('models', index)")
          .objects__row
            .row__title
              .title__icon(v-html="$icons.backgrounds")
              span.title__text Backgrounds
            .row__list
                img.list__item(v-for="(background, index) in backgrounds.items" :src="background" :class="backgrounds.active === index && 'list__item--active'" @click="handleClick('backgrounds', index)")
          .objects__row
            .row__title
              .title__icon(v-html="$icons.objects")
              span.title__text Objects
            .row__list
                img.list__item(v-for="(object, index) in objects.items" :src="object" :class="objects.active === index && 'list__item--active'" @click="handleClick('objects', index)")
        parallax-container.frame__canvas
          parallax-element.canvas__image(:parallaxStrength="15" :type="'depth'")
            .image__border
                img.border__item(v-for="(border, index) in borders.items" :src="border" :class="borders.active === index && 'border__item--active'")
            .image__object
                img.object__item(v-for="(object, index) in objects.items" :src="object" :class="objects.active === index && 'object__item--active'")
            .image__model
              img.model__item(v-for="(model, index) in models.items" :src="model.path" :class="models.active === index && 'model__item--active'")
            .image__background
              img.background__item(v-for="(background, index) in backgrounds.items" :src="background" :class="backgrounds.active === index && 'background__item--active'")
          parallax-element.canvas__button(:parallaxStrength="1" :type="'translation'")
            a(:href="editSceneLink")
              span Edit scene
              .button__icon(v-html="$icons.buttonArrow")
          .canvas__circle
</template>

<script>
import { mapState, mapGetters } from "vuex";
import { TimelineLite } from "gsap";

export default {
  computed: {
    ...mapState({
      borders: state => state.landing.borders,
      models: state => state.landing.models,
      backgrounds: state => state.landing.backgrounds,
      objects: state => state.landing.objects
    }),
    ...mapGetters(["editSceneLink"])
  },
  methods: {
    handleClick: function(category, index) {
      this.$store.commit("SET_ACTIVE", { category, index });
      this.animateImage();
    },
    animateImage: function() {
      const circleTimeline = new TimelineLite();
      const imageTimeline = new TimelineLite();

      TweenLite.set(".canvas__circle", {
        visibility: "visible",
        perspective: 400
      });

      circleTimeline.fromTo(
        ".canvas__circle",
        1.2,
        {
          opacity: 1,
          scale: 0,
          ease: Back.easeOut
        },
        {
          opacity: 0,
          scale: 2,
          ease: Back.easeOut
        },
        "+=0"
      );

      imageTimeline
        .fromTo(
          ".canvas__image",
          0.2,
          {
            scale: 1,
            ease: Back.easeOut
          },
          {
            scale: 1.025,
            ease: Back.easeOut
          },
          "+=0"
        )
        .to(".canvas__image", 0.2, { scale: 1 }, "+=0");
    }
  }
};
</script>

<style lang="scss" scoped>
.editor {
  width: 100%;
  height: 100%;
  color: #fff;
  margin-top: 80px;

  &__description {
    display: flex;
    flex-direction: column;
    align-items: center;
    font-weight: 400;
    text-align: center;
    margin-bottom: 16px;

    @media (min-width: 768px) {
      margin-bottom: 56px;
    }

    & .description {
      &__title {
        font-weight: 600;
        font-size: 32px;
        letter-spacing: -1px;
        text-transform: uppercase;
        margin-bottom: 24px;

        @media (min-width: 768px) {
          font-size: 40px;
          letter-spacing: -0.03em;
        }

        &--outline {
          color: rgba(255, 255, 255, 0);
          -webkit-text-stroke-width: 1px;
          -webkit-text-stroke-color: #fff;
        }
      }

      &__description {
        margin: 0 auto;
        font-size: 15px;
        line-height: 22px;
        opacity: 0.5;
        margin-bottom: 16px;

        @media (min-width: 768px) {
          width: 60%;
        }
      }

      &__link {
        display: flex;
        font-size: 15px;
        font-weight: 500;
        line-height: 20px;
        padding: 16px;
        color: #ff95aa;
        text-decoration: none;
        transition: 0.15s;

        &:hover {
          color: #fff;

          .link__icon {
            fill: #fff;
          }
        }

        & .link {
          &__label {
          }

          &__icon {
            display: inline-block;
            position: relative;
            top: 2px;
            width: 14px;
            height: 20px;
            margin-left: 8px;
            fill: #ff95aa;
          }
        }
      }
    }
  }

  &__frame {
    display: flex;
    flex-direction: column-reverse;
    align-items: center;

    @media (min-width: 768px) {
      flex-direction: row;
    }

    & .frame {
      &__objects {
        display: flex;
        align-items: center;
        width: 100%;
        flex: 1;
        overflow-x: scroll;

        @media (min-width: 768px) {
          width: auto;
          flex-direction: column;
          overflow-x: auto;
        }

        & .objects {
          &__row {
            width: 80%;
            margin-right: 32px;

            &:last-child {
              margin-right: 0;
            }

            @media (min-width: 768px) {
              margin-right: 0;
              margin-bottom: 40px;

              &:last-child {
                margin-bottom: 0;
              }
            }

            & .row {
              &__title {
                display: flex;
                align-items: center;

                & .title {
                  &__icon {
                    width: 16px;
                    height: 20px;
                  }

                  &__text {
                    font-size: 15px;
                    font-weight: 400;
                    line-height: 22px;
                    margin-left: 12px;
                  }
                }
              }

              &__list {
                display: flex;
                justify-content: space-between;
                align-items: center;
                margin-top: 16px;

                & .list {
                  &__item {
                    width: 50px;
                    height: 58px;
                    margin-right: 0.5em;
                    background: #f5f5f5;
                    border-radius: 4px;
                    opacity: 0.3;
                    transition: 0.2s;
                    cursor: pointer;

                    @media (min-width: 900px) {
                      margin-right: 0;
                      width: 80px;
                      height: 96px;
                    }

                    &:hover {
                      transform: scale(1.1);
                      opacity: 0.5;
                    }

                    &--active {
                      width: 66px;
                      height: 74px;
                      box-shadow: 0px 0px 25px rgba(#000, 0.25);
                      opacity: 1;

                      @media (min-width: 900px) {
                        width: 96px;
                        height: 112px;
                      }

                      &:hover {
                        transform: scale(1);
                        opacity: 1;
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }

      &__canvas {
        display: flex;
        justify-content: center;
        align-items: center;
        position: relative;
        flex: 1;
        width: 100%;
        height: 108vw;
        overflow: hidden;

        @media (min-width: 576px) {
          width: 80%;
          height: 90vw;
        }

        @media (min-width: 768px) {
          height: 60vw;
        }

        @media (min-width: 1024px) {
          width: auto;
          height: 614px;
        }

        &:hover {
          & .canvas__button {
            opacity: 1;
          }

          & .canvas__button .button__icon {
            opacity: 1;
            transform: translateX(10px);
          }

          & .canvas__image .image__border .border__item--active {
            opacity: 1;
          }
        }

        & .canvas {
          &__image {
            position: relative;
            width: 90%;
            height: 90%;
            background: rgba(#fff, 0.1);
            border-radius: 6px;
            overflow: hidden;

            & .image {
              &__object {
                & .object {
                  &__item {
                    position: absolute;
                    top: 0;
                    left: 0;
                    width: 100%;
                    height: 100%;
                    opacity: 0;
                    visibility: hidden;
                    z-index: 3;
                    transition: 0.4s;

                    &--active {
                      opacity: 1;
                      visibility: visible;
                      z-index: 3;
                      transition: 0.4s;
                    }
                  }
                }
              }

              &__model {
                & .model {
                  &__item {
                    position: absolute;
                    top: 0;
                    left: 0;
                    width: 100%;
                    height: 100%;
                    opacity: 0;
                    visibility: hidden;
                    z-index: 2;
                    transition: 0.2s;

                    &--active {
                      opacity: 1;
                      visibility: visible;
                      transition: 0.2s;
                    }
                  }
                }
              }

              &__background {
                & .background {
                  &__item {
                    position: absolute;
                    top: 0;
                    left: 0;
                    width: 100%;
                    height: 100%;
                    opacity: 0;
                    visibility: hidden;
                    z-index: -1;
                    transition: 0.6s;

                    &--active {
                      opacity: 1;
                      visibility: visible;
                      z-index: 1;
                      transition: 0.6s;
                    }
                  }
                }
              }

              &__border {
                & .border {
                  &__item {
                    position: absolute;
                    top: 0;
                    left: 0;
                    width: 100%;
                    height: 100%;
                    opacity: 0;
                    visibility: hidden;
                    z-index: -1;
                    transition: 0.2s;

                    &--active {
                      visibility: visible;
                      z-index: 3;
                      transition: 0.2s;
                    }
                  }
                }
              }
            }
          }

          &__button {
            position: absolute;
            margin-bottom: 16px;
            background: #fff;
            font-size: 15px;
            font-weight: 500;
            border-radius: 32px;
            transition: 0.2s;
            opacity: 0;

            & a {
              display: flex;
              justify-content: center;
              padding: 16px 56px 16px 36px;
              color: #1a1a1a;
              text-decoration: none;
            }

            &:hover {
              background: #1a1a1a;
            }

            &:hover a {
              color: #fff;
            }

            &:hover .button__icon {
              fill: #fff;
            }

            & .button {
              &__icon {
                display: inline-block;
                position: absolute;
                right: 42px;
                top: 34%;
                width: 14px;
                height: 20px;
                margin-left: 8px;
                fill: #1a1a1a;
                opacity: 0;
                transition: 0.2s;
              }
            }
          }

          &__circle {
            position: absolute;
            width: 100%;
            height: calc(45vw / 1.25);
            background: #fff;
            border-radius: 100%;
            visibility: hidden;
            z-index: -1;
          }
        }
      }
    }
  }
}

.wrapper {
  position: relative;
  margin: 0 auto;
  padding: 32px 0;
  max-width: 1040px;

  @media (max-width: 1024px) {
    padding: 32px 16px;
  }
}
</style>
